package io.accumulatenetwork.sdk.generated.managed;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import io.accumulatenetwork.sdk.generated.apiv2.MerkleState;
import io.accumulatenetwork.sdk.protocol.Marshallable;
import io.accumulatenetwork.sdk.support.Marshaller;
// UnionType: 
// UnionValue: 

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("Snapshot")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class Snapshot implements Marshallable {
	private String name;
	private ChainType type;
	private long markPower;
	private MerkleState head;
	private MerkleState[] markPoints;

    //
	public String getName() {
	    return name;
	}
	public void setName(final String value) {
	    this.name = value;
	}

	public Snapshot name(final String value) {
	    setName(value);
	    return this;
	}
	public ChainType getType() {
	    return type;
	}
	public void setType(final ChainType value) {
	    this.type = value;
	}

	public Snapshot type(final ChainType value) {
	    setType(value);
	    return this;
	}
	public long getMarkPower() {
	    return markPower;
	}
	public void setMarkPower(final long value) {
	    this.markPower = value;
	}

	public Snapshot markPower(final long value) {
	    setMarkPower(value);
	    return this;
	}
	public MerkleState getHead() {
	    return head;
	}
	public void setHead(final MerkleState value) {
	    this.head = value;
	}

	public Snapshot head(final MerkleState value) {
	    setHead(value);
	    return this;
	}
	public MerkleState[] getMarkPoints() {
	    return markPoints;
	}
	public void setMarkPoints(final MerkleState[] value) {
	    this.markPoints = value;
	}

	public Snapshot markPoints(final MerkleState[] value) {
	    setMarkPoints(value);
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        if (!(this.name == null || this.name.length() == 0)) {
            marshaller.writeString(1, this.name);
        }
        if (!(this.type == null)) {
            marshaller.writeValue(2, type);
        }
        if (!(this.markPower == 0)) {
            marshaller.writeUint(3, this.markPower);
        }
        if (!(this.head == null)) {
            marshaller.writeValue(4, head);
        }
        if (!(this.markPoints == null)) {
            marshaller.writeValue(5, markPoints);
        }
        return marshaller.array();
    }
}
